; ===============================================================
; ===============================================================
.386
name LOGO
; ===============================================================
;   ===  : ===
CSEG segment use16
assume cs:cseg, ds:cseg, ss:cseg, es:cseg
org  100h			; COM 
; ===============================================================
Start:

	mov	ax, 3D00h	;     
	lea	dx, file	;      
	int	21h
	jnc	File_Exist

	lea     dx, No_File	;   
        mov     ah, 09h		; 
        int     21h		;

	int	20h		;   

File_Exist:

	mov	handle, ax

; ===    ===

	lea     bx, Finish
	shr     bx,4
	inc     bx
	mov     ah,4Ah
	int     21h		;       Finish

	mov     ah, 48h		;     
	mov     bx, 4096	; 4096 * 16 = 65536  = 1 
	int     21h
	jnc     Memory_OK
; ---
	mov	ah, 3eh		;  
	mov	bx, handle
	int	21h

	lea     dx, Memory_Error
        mov     ah, 09h		;    
        int     21h		;

	int	20h		;   

Memory_OK:

	mov	Buffer,ax	;      

; ===    ===

	mov	ax,4F02h	;   
	mov	bx,101h
	int	10h
; ---
	mov	ax, 4200h	;     
	mov	bx, handle
	xor	cx, cx
	mov	dx, 54		;  54  -  
	int	21h

	push	Buffer		;        
	pop	ds

	mov 	ah, 3fh		;   
;	mov 	bx, handle	; 
	mov 	cx, 1024	;  1024 
	xor	dx, dx		;   
	int 	21h		;
	jnc 	Pallete_OK	;   
; ---
	push	cs		;       
	pop	ds

	mov	es,Buffer	;      
	mov     ah, 49h		;  es  
	int     21h

	mov	ah, 3eh		;  
;	mov	bx, handle
	int	21h

	mov	ax,3h		;     
	int	10h

	lea     dx, Read_Error
        mov     ah, 09h		;    
        int     21h		;

	int	20h		;   

Pallete_OK:

	push	ds
	pop	es		; ES:DI =       (256 ) 
	mov	di,8000h
	mov	ax,4f01h	;    
	mov	cx,101h		;  =  SVGA- ( 14   LFB,  13   )
	int	10h		; +0Ch: 4       (  05h,   )

	xor	ax, ax
	mov	si, 1024
	mov	cx, 100h

Next_Color:

	mov	dx,3c8h
	mov	al, cl		; .  cx  100h  al  0 
	dec	ax		;    1  al    FF
	out	dx,al

	mov	dx,3c9h

	dec	si		;      BMP
	dec	si		; RED
	mov	al, byte ptr[si]	;  BMP    
	shr	ax, 2
	out	dx,al

	dec	si		; GREEN
	mov	al, byte ptr[si]
	shr	ax, 2
	out	dx,al

	dec	si		; BLUE
	mov	al, byte ptr[si]
	shr	ax, 2
	out	dx,al

	loop	Next_Color

	push	0A000h		;  es    
	pop	es
	mov	word ptr ds:[8002h], 0	;   

; ===   ===
Next_Page:

	push	bx		; bx      
	mov	ax, 4F05h
	xor	bx, bx
	mov	dx, word ptr ds:[8002h]
;	int	10h
	call	dword ptr ds:[800ch]
	pop	bx

	mov 	ah, 3fh		;   
;	mov 	bx, handle	; 
	mov 	cx, 8000h	;  32768 
	xor	dx, dx		;   
	int 	21h		;

	xor	si, si
	xor	di, di
;	shr	ax, 2
;	mov	cx, ax
	mov	cx, 2000h
	Rep	movsd		; DS:SI  ES:DI

	mov 	ah, 3fh		;   
;	mov 	bx, handle	; 
	mov 	cx, 8000h	;  32768 
	xor	dx, dx		;   
	int 	21h		;

	xor	si, si 
	mov	di, 8000h
	shr	ax, 2
	mov	cx, ax
	Rep	movsd		; DS:SI  ES:DI

	inc	word ptr ds:[8002h]
	cmp	word ptr ds:[8002h], 5
	jb	Next_Page

; ===   ===

	push	ds
	pop	es

	push	cs
	pop	ds

;	mov	es,Buffer	;     
	mov     ah, 49h		; es  
	int     21h

	mov	ah, 3eh		;  
;	mov	bx, handle
	int	21h

        mov     ah, 0 
        int     16h		;    

	mov	ax,3h		;     
	int	10h

	int	20h		;   

; ===   ===
Buffer		dw	?		;   
handle		dw	?		;  
file		db	'LOGO.BMP',0	;  
No_File		db	'訡  䠩', 0Dh,0Ah, 24h	;   
Read_Error	db      '訡 ⥭ 䠩', 0Dh,0Ah, 24h	;   
Memory_Error	db      '訡 ', 0Dh, 0Ah, 24h		;     
; ---
Finish:		;   
CSEG ends
end Start